# Random Walk (RW), zweidimensionales Gitter
# <R^2> über nKonfig Konfigurationen
from gpanel import *    # importiere Graphik Bibliothek
from random import *    # importiere Bibliothek für Zufallszahlen
graphik  = True  # graphische Ausgabe
nKonfig  = 1000  # Zahl der Konfigurationen
dauer    =  30   # Zeitverzögerung für die graphische Ausgabe
SegZahl1 =  50   # Zahl der Segmente von
SegZahl2 = 100   #    bis

for nsegm in range(SegZahl1,SegZahl2,1):
    if graphik==True:
        makeGPanel(Size(800,800))
        font(Font("Courier", Font.PLAIN, 20))  
        lineWidth(3)    
        delay(dauer)         

    indmol = 0
    R2sum  = 0
    for nmol in range(0,nKonfig):
        xpos  = [0 for i in range(1001)] 
        ypos  = [0 for i in range(1001)] 
        km = 5    
        xk = 0
        yk = 0
        xpos[0] = 0
        ypos[0] = 0
        ind=0
        for n in range(1,nsegm+1):
            i = randint(1,4)
            if i==1: xk = xk + 1
            if i==2: xk = xk - 1
            if i==3: yk = yk + 1
            if i==4: yk = yk - 1
            xpos[n] = xk
            ypos[n] = yk
            ind = ind + 1
            if graphik==True:
                km = max(km,abs(xk),abs(yk))
                window(-1.1*km,1.1*km,-1.1*km,1.1*km)
                setColor("white")
                fillRectangle(-1.05*km,-1.05*km,1.05*km,1.05*km)       
                setColor("black")
                rectangle(-1.05*km,-1.05*km,1.05*km,1.05*km)
                move(0,0)
                fillCircle(0.03*km)
                for ll in range(0,n+1): 
                    draw(xpos[ll],ypos[ll])
                    fillCircle(0.02*km)
                setColor("red")
                fillCircle(0.03*km)
                setColor("black")
                text(-km,km*1.05,"random walk",Font("Courier", Font.BOLD, 20), "black", "white")                
                text(-km,km*0.95,str(n),Font("Courier", Font.BOLD, 30), "black", "white")                
                delay(dauer)

        R2     = xk**2+yk**2 
        R2sum  = R2sum + R2
        indmol = indmol + 1
        if graphik==True:
            setColor("blue")
            move(xpos[0],ypos[0])
            draw(xpos[n],ypos[n])
            setColor("black")
            delay(20*dauer)

    R2av = R2sum/indmol
    print ind,R2av
